/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "Stopwatch.h"
#include <unistd.h>

@implementation Stopwatch


+ (void) delay:(unsigned long) milliseconds
{
   struct timeval   wait;

   wait.tv_sec  = milliseconds / 1000;
   wait.tv_usec = (milliseconds % 1000) * 1000;
   select( 0, NULL, NULL, NULL, &wait);  // use select as sleepMs
}


- (void) start
{
   gettimeofday( &_start, NULL);
   running = YES;
}


- (void) calcElapsed
{
   long   us;
   int    carry;
   
   if( ! running)
      [NSException raise:NSGenericException
                  format:@"Stopwatch %@ ain't running", self];
   gettimeofday( &_stop, NULL);

   if( carry = _stop.tv_usec < _start.tv_usec)
      us = 1000000 - _start.tv_usec + _stop.tv_usec;
   else
      us = _stop.tv_usec - _start.tv_usec;
      
   elapsed = (_stop.tv_sec - _start.tv_sec - carry) * 1000 + us / 1000;
}


- (void) stop
{
   [self calcElapsed];
   running = NO;
}   


- (unsigned long) elapsedMilliseconds
{
   if( running)
      [self calcElapsed];
   return( elapsed);
}


@end
